<?php
if ( ! class_exists( 'IPTrank_Admin' )) {

    /**
     * Class for handling administrator page
     */
    class IPTrank_Admin
    {
        /**
         * Show content admin home
         *
         * @return void
         */
        public function dashboard()
        {
            /* $engine = new IPTrank_Engine( 'iznyn', 'iznyn.com' );
            $rank   = $engine->run();
            var_dump( $rank ); */
            
        ?>
            <script type="text/javascript">
                iptrank_mng_msg = {
                    'site_empty'     : '<?php _e( 'You must specify a site', 'iptrank' ); ?>',
                    'keywords_empty' : '<?php _e( 'You must specify one or more keywords', 'iptrank' ); ?>',
                    'group_empty'    : '<?php _e( 'You must specify a group', 'iptrank' ); ?>'
                };
            </script>
            <div id="iptrank-admin" class="wrap ipadm-wrap iptrank-admin">
                <div class="ipadm-inner">
                    <div class="ipadm-header">
                        <div class="iptrank-page-title">
                            <h1><?php _e( 'EZ Rank Track', 'iptrank' ); ?></h1>
                        </div>
                        <div class="iptrank-page-subtitle">
                            <h3><?php _e( 'Dashboard', 'iptrank' ); ?></h3>
                        </div>
                        <div class="iptrank-page-btn">
                            <a class="iptrank-btn-modal ipadm-btn ipadm-btn-primary" href="#iptrank-popup-keywords"><?php _e( 'Add keywords', 'iptrank' ); ?></a>
                        </div>
                    </div>
                    <div class="ipadm-body">
                        <div class="ipadm-main">
                            <div class="ipadm-manage">
                                
                                <div id="iptrank-keywords-manage" class="ipadm-table iptrank-manage-table">
                                    <form action="" method="get">
                                        <input type="hidden" name="page" value="iptrank">
                                        <?php
                                        require_once( IPTRANK_PATH . "includes/admin-table.php" );
                                        $paginArgs = array(
                                            "per_page" => 20 
                                        );
                                        $table = new IPTrank_AdminTable();
                                        $table->prepare_items();
                                        $table->display();
                                        ?>
                                    </form>
                                </div>
                                
                            </div>
                            <div id="iptrank-keyword-reports">
                                
                                <?php
                                $tab = 'iptrank-tab-chart';
                                if ( ! empty( $_REQUEST['tab'] )) {
                                    $tab = $_REQUEST['tab'];
                                }
                                ?>
                            <div class="iptrank-manage-tab">
                                <div class="iptrank-page-subtitle"><h4>
                                <?php
                                $rank   = false;
                                $_ranks = $table->items;
                                if ( ! empty( $_ranks )) {
                                    $rank = array_shift( $_ranks );
                                }
                                printf( __( 'Ranking Reports of %s for %s', 'iptrank' ), $rank->rank_site, $rank->rank_keyword );
                                ?>
                                </h4></div>
                                <form action="" method="post">
                                    <input type="hidden" name="tab_selected" id="iptrank-tab-selected" value="<?php echo $tab; ?>" />
                                    <div class="iptrank-tab-nav">
                                        <ul>
                                            <li class="iptrank-tab-menu">
                                                <a href="#iptrank-tab-chart">
                                                    <i class="faip fa-signal"></i>
                                                    <span><?php _e( 'Rank Chart', 'iptrank' ); ?></span>
                                                </a>
                                            </li>
                                            <li class="iptrank-tab-menu">
                                                <a href="#iptrank-tab-record">
                                                    <i class="faip fa-file-text-o"></i>
                                                    <span><?php _e( 'Rank Records', 'iptrank' ); ?></span>
                                                </a>
                                            </li>
                                        </ul>
                                    </div>
                                    <div class="iptrank-tab-sections">
                                        <div id="iptrank-tab-chart" class="iptrank-tab-section">
                                            <div class="iptrank-tab-header">
                                                <h4><?php _e( 'Rank Chart', 'iptrank' ); ?></h4>
                                                <h5><?php _e( 'See keyword ranking report in the form of charts.', 'iptrank' ); ?></h5>
                                            </div>
                                            <div class="iptrank-fields">
                                                <?php
                                                if ( ! empty( $rank ) ) :
                                                ?>
                                                <script type="text/javascript" src="https://www.google.com/jsapi"></script>
                                                <script type="text/javascript">
                                                    google.load("visualization", "1", {packages:["corechart"]});
                                                    google.setOnLoadCallback(drawChart);
                                                    function drawChart() {
                                                        
                                                        var dataTable = new google.visualization.DataTable();
                                                        dataTable.addColumn( 'date', '<?php _e( 'Date', 'iptrank' ); ?>' );
                                                        dataTable.addColumn( 'number', '<?php _e( 'Rank', 'iptrank' ); ?>' );
                                                        
                                                        var rows = [
                                                            <?php
                                                            $model   = new IPTrank_Model();
                                                            $results = $model->get_keyword_stat_data( $rank->rank_id );
                                                            if ( ! empty( $results )) {
                                                                foreach( $results as $data )
                                                                {
                                                                    $timestamp = strtotime( $data->rdate );
                                                                    $phpdate   = getdate($timestamp);
                                                                    $value     = (int)$data->rank;
                                                                    
                                                                    echo '[new Date(' 
                                                                            . $phpdate['year'] . ', '
                                                                            . ( $phpdate['mon']  - 1 ) . ', '
                                                                            . $phpdate['mday'] . ',0,0,0), '
                                                                            . $value
                                                                        . '],';
                                                                }
                                                            }
                                                            ?>
                                                        ];
                                                        dataTable.addRows( rows );
                                                        
                                                        var options = {
                                                            series: [{pointSize:6}],
                                                            vAxis: {direction: -1}
                                                        };
                                                        var chart = new google.visualization.LineChart(document.getElementById('iptrank-chart-div'));
                                                        chart.draw(dataTable, options);
                                                    }
                                                </script>
                                                <div id="iptrank-chart-div" style="width: 100%; height: 400px;"></div>
                                                <?php
                                                endif;
                                                ?>
                                            </div>
                                        </div>
                                        <div id="iptrank-tab-record" class="iptrank-tab-section" style="display:none;">
                                            <div class="iptrank-tab-header">
                                                <h4><?php _e( 'Rank Records', 'iptrank' ); ?></h4>
                                                <h5><?php _e( 'See all keyword ranking report.', 'iptrank' ); ?></h5>
                                            </div>
                                            <div class="iptrank-fields">
                                                <?php
                                                if ( ! empty( $rank ) ) :
                                                ?>
                                                <div class="ipadm-clear">
                                                    <div class="iptrank-col-stat">
                                                        <h4 class="iptrank-page-section"><?php _e( '10 Last Ranking Records', 'iptrank' ); ?></h4>
                                                        <table class="iptrank-stat-table">
                                                            <thead>
                                                                <tr>
                                                                    <th><?php _e( 'No', 'iptrank' ); ?></th>
                                                                    <th><?php _e( 'Date', 'iptrank' ); ?></th>
                                                                    <th><?php _e( 'Rank', 'iptrank' ); ?></th>
                                                                </tr>
                                                            </thead>
                                                <tbody>
                                                <?php
                                                $records = $model->get_records( $rank->rank_id, 10 );
                                                if ( ! empty( $records )) :
                                                    $idx = 1;
                                                    foreach( $records as $record ):
                                                ?>
                                                    <tr>
                                                        <td><?php echo $idx; ?></td>
                                                        <td><?php echo mysql2date( 'd M y, h:i', $record->reco_date ); ?></td>
                                                        <td>
                                                            <?php
                                                            $value = $record->reco_value;
                                                            if ( $value == 0 || $value > 100 ) {
                                                                $value = '100+';
                                                            }
                                                            $value = '<span class="iptrank-rank-value">' . $value . '</span>';
                                                            //Progress
                                                            if ( $record->reco_progress > 0 ) {
                                                                $icon = '<span class="ipadm-btn ipadm-btn-success ipadm-btn-small iptrank-rank-status"><i class="faip fa-long-arrow-up"></i></span>';
                                                            } elseif ( $record->reco_progress == 0 ) {
                                                                $icon = '<span class="ipadm-btn ipadm-btn-warning ipadm-btn-small iptrank-rank-status"><i class="faip fa-arrows-h"></i></span>';
                                                            } else {
                                                                $icon = '<span class="ipadm-btn ipadm-btn-danger ipadm-btn-small iptrank-rank-status"><i class="faip fa-long-arrow-down"></i></span>';
                                                            }
                                                            $value .= $icon;
                                                            if ( ! empty( $record->reco_progress )) {
                                                                if ( $record->rank_progress > 0 ) {
                                                                    $val = '+'.$record->rank_progress;
                                                                } else {
                                                                    $val = $record->rank_progress;
                                                                }
                                                                $value .= "( $val )";
                                                            }
                                                            echo $value;
                                                            ?>
                                                        </td>
                                                    </tr>
                                                <?php
                                                        $idx++;
                                                    endforeach;
                                                endif;
                                                ?>
                                                </tbody>
                                                        </table>
                                                    </div>
                                                    <div class="iptrank-col-stat iptrank-col-right">
                                                        <h4 class="iptrank-page-section"><?php _e( '10 Best Ranking Records', 'iptrank' ); ?></h4>
                                                        <table class="iptrank-stat-table">
                                                            <thead>
                                                                <tr>
                                                                    <th><?php _e( 'No', 'iptrank' ); ?></th>
                                                                    <th><?php _e( 'Date', 'iptrank' ); ?></th>
                                                                    <th><?php _e( 'Rank', 'iptrank' ); ?></th>
                                                                </tr>
                                                            </thead>
                                                <tbody>
                                                <?php
                                                $records = $model->get_best_records( $rank->rank_id, 10 );
                                                if ( ! empty( $records )) :
                                                    $idx = 1;
                                                    foreach( $records as $record ):
                                                ?>
                                                    <tr>
                                                        <td><?php echo $idx; ?></td>
                                                        <td><?php echo mysql2date( 'd M y, h:i', $record->reco_date ); ?></td>
                                                        <td>
                                                            <?php
                                                            $value = $record->reco_value;
                                                            if ( $value == 0 || $value > 100 ) {
                                                                $value = '100+';
                                                            }
                                                            $value = '<span class="iptrank-rank-value">' . $value . '</span>';
                                                            //Progress
                                                            if ( $record->reco_progress > 0 ) {
                                                                $icon = '<span class="ipadm-btn ipadm-btn-success ipadm-btn-small iptrank-rank-status"><i class="faip fa-long-arrow-up"></i></span>';
                                                            } elseif ( $record->reco_progress == 0 ) {
                                                                $icon = '<span class="ipadm-btn ipadm-btn-warning ipadm-btn-small iptrank-rank-status"><i class="faip fa-arrows-h"></i></span>';
                                                            } else {
                                                                $icon = '<span class="ipadm-btn ipadm-btn-danger ipadm-btn-small iptrank-rank-status"><i class="faip fa-long-arrow-down"></i></span>';
                                                            }
                                                            $value .= $icon;
                                                            if ( ! empty( $record->reco_progress )) {
                                                                    if ( $record->rank_progress > 0 ) {
                                                                        $val = '+'.$record->rank_progress;
                                                                    } else {
                                                                        $val = $record->rank_progress;
                                                                    }
                                                                    $value .= "( $val )";
                                                            }
                                                            echo $value;
                                                            ?>
                                                        </td>
                                                    </tr>
                                                <?php
                                                        $idx++;
                                                    endforeach;
                                                endif;
                                                ?>
                                                </tbody>
                                                        </table>
                                                    </div>
                                                </div>
                                                <?php
                                                endif;
                                                ?>
                                            </div>
                                        </div>
                                    </div>
                                </form>
                            </div>
                            <div class="iptrank-section-full-loader" style="display:none;">
                                <?php
                                $plgurl = plugin_dir_url( dirname(__FILE__) );
                                $src    = $plgurl . 'img/loading.gif';
                                ?>
                                <img src="<?php echo $src; ?>" alt="Loading..." />
                            </div>
                            
                            </div>
                            
                        </div>
                    </div>
                </div>

<div id="iptrank-popup-keywords" class="ip-ui-modal" style="display:none;">
    <div class="ip-ui-modal-main">
        <div class="ip-ui-modal-inner">
            <div class="ip-ui-modal-title">
                <h3><?php _e( 'Add New Keywords', 'iptrank' ); ?></h3>
                <div class="ip-ui-close">
                    <a href="#"><i class="faip fa-times"></i></a>
                </div>
            </div>
            <div class="ip-ui-modal-content ip-form-cont">
                <form id="iptrank-add-keywords-form" action="<?php echo admin_url(); ?>admin-ajax.php?doajax=1&iptrank=1&action=iptrank_save_keyword" method="post">
                
                    <div class="ipadm-field-row ipadm-field-inline ipadm-field-box ipadm-clear">
                        <div class="ipadm-label">
                            <label for="iptrank-input-site"><?php _e( 'Site', 'iptrank' ); ?></label>
                        </div>
                        <div class="ipadm-field">
                            <div class="ipadm-input-wrap">
                                <input type="text" class="ipadm-input" id="iptrank-input-site" name="site" value="" />
                            </div>
                        </div>
                    </div>
                    <div class="ipadm-field-row ipadm-field-inline ipadm-field-box ipadm-clear">
                        <div class="ipadm-label">
                            <label for="iptrank-input-keywords"><?php _e( 'Keywords', 'iptrank' ); ?></label>
                        </div>
                        <div class="ipadm-field">
                            <div class="ipadm-input-wrap">
                                <textarea class="ipadm-input ipadm-input-full" id="iptrank-input-keywords" name="keywords"></textarea>
                            </div>
                            <p class="ipadm-info"><?php _e( 'Add your keywords, one keyword perline', 'iptrank' ); ?></p>
                        </div>
                    </div>
                    <div class="ipadm-field-row ipadm-field-inline ipadm-field-box ipadm-clear">
                        <div class="ipadm-label">
                            <label for="iptrank-input-sc-ad"><?php _e( 'Group', 'iptrank' ); ?></label>
                        </div>
                        <div class="ipadm-field">
                            <div class="ipadm-input-wrap">
                                <div class="iptrank-input">
                                    <select name="group" id="iptrank-input-group">
                                        <?php
                                        $model  = new IPTrank_Model();
                                        $groups = $model->get_groups();
                                        foreach( $groups as $group )
                                        {
                                            echo '<option value="' . $group->group_id . '">' . $group->group_name . '</option>';
                                        }
                                        ?>
                                    </select>
                                    <a class="addgroup-btn ipadm-btn ipadm-btn-default ipadm-btn-small" href=""><?php _e( 'Add new group', 'iptrank' ); ?></a>
                                </div>
                                <div class="iptrank-field-newgroup" style="display:none;">
                                    <input type="text" class="ipadm-input ipadm-input-full" id="iptrank-input-newgroup" name="newgroup" value="" placeholder="New group" />
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="ipadm-field-row ipadm-field-box ipadm-clear">
                        <div class="ipadm-field">
                            <div class="ipadm-input-wrap">
                                <input type="submit" class="ipadm-btn ipadm-btn-primary ip-form-submit" name="iptrank_add_keywords" id="iptrank-do-addkeyw" value="<?php _e( 'Add keywords', 'iptrank' ); ?>" />
                            </div>
                        </div>
                    </div>
                    
                </form>
            </div>
        </div>
    </div>
</div>
                
            </div>
        <?php
        }
        
        /**
         * Show content for detail keyword report
         *
         * @return void
         */
        public function view_site()
        {
            $model = new IPTrank_Model();
            
            if ( empty( $_GET['id'] )) {
                wp_die( __('You attempted to edit an item that doesn&#8217;t exist. Perhaps it was deleted?', 'iptrank') );
            }
            $id = absint( $_GET['id'] );
            if ( ! $rank = $model->get_rank( $id ) ) {
                wp_die( __('You attempted to edit an item that doesn&#8217;t exist. Perhaps it was deleted?', 'iptrank') );
            }
            $csite  = $rank->rank_site;
            $cgroup = 0;
        ?>
            <div id="iptrank-admin" class="wrap ipadm-wrap iptrank-admin">
                <div class="ipadm-inner">
                    <div class="ipadm-header">
                        <div class="iptrank-page-title">
                            <h1><?php _e( 'EZ Rank Track', 'iptrank' ); ?></h1>
                        </div>
                        <div class="iptrank-page-subtitle">
                            <h3><?php _e( 'Site Report:', 'iptrank' ); ?> <em><?php echo $rank->rank_site; ?></em></h3>
                        </div>
                    </div>
                    <div class="ipadm-body">
                        <div class="ipadm-main">
                            <div class="ipadm-manage">
                                
                                <div id="iptrank-site-report">
                                    <div class="iptrank-report-nav ipadm-clear">
                                        <div class="iptrank-report-filter">
                                            <form action="" method="get">
                                                <select name="date" id="iptrank-input-date">
                                                    <?php
                                                    $cdate = 1;
                                                    if ( ! empty( $_GET['date'] )) {
                                                        $cdate = absint( $_GET['date'] );
                                                    }
                                                    $dates = array(
                                                        1 => __( 'By Month', 'iptrank' ),
                                                        2 => __( 'By Year', 'iptrank' )
                                                    );
                                                    foreach( $dates as $key => $name ) 
                                                    {
                                                        $sltd = '';
                                                        if ( $key === $cdate ) {
                                                            $sltd = ' selected="selected"';
                                                        }
                                                        echo '<option value="'.$key.'"'.$sltd.'>'.$name.'</option>';
                                                    }
                                                    ?>
                                                </select>
                                                <?php
                                                $dsp = ' style="display:none;"';
                                                if ( $cdate == 1 ) {
                                                    $dsp = '';
                                                }
                                                ?>
                                                <span id="iptrank-field-month" class="iptrank-filter-field"<?php echo $dsp; ?>>
                                                    <select name="month" id="iptrank-input-month">
                                                        <?php
                                                        $cmonth = date( 'm' );
                                                        if ( ! empty( $_GET['month'] )) {
                                                            $cmonth = preg_replace( '@[^0-9]@', '', $_GET['month'] );
                                                        }
                                                        $months = array(
                                                            '01' => __( 'Jan', 'iptrank' ),
                                                            '02' => __( 'Feb', 'iptrank' ),
                                                            '03' => __( 'Apr', 'iptrank' ),
                                                            '04' => __( 'Mar', 'iptrank' ),
                                                            '05' => __( 'May', 'iptrank' ),
                                                            '06' => __( 'Jun', 'iptrank' ),
                                                            '07' => __( 'Jul', 'iptrank' ),
                                                            '08' => __( 'Aug', 'iptrank' ),
                                                            '09' => __( 'Sep', 'iptrank' ),
                                                            '10' => __( 'Oct', 'iptrank' ),
                                                            '11' => __( 'Nov', 'iptrank' ),
                                                            '12' => __( 'Dec', 'iptrank' )
                                                        );
                                                        foreach( $months as $id => $name )
                                                        {
                                                            $sltd = '';
                                                            if ( $id == $cmonth ) {
                                                                $sltd = ' selected="selected"';
                                                            }
                                                            echo '<option value="'.$id.'"'.$sltd.'>'.$name.'</option>';
                                                        }
                                                        ?>
                                                    </select>
                                                </span>
                                                <span id="iptrank-field-year" class="iptrank-filter-field">
                                                    <select name="year" id="iptrank-input-year">
                                                        <?php
                                                        $cyear = date( 'Y' );
                                                        if ( ! empty( $_GET['year'] )) {
                                                            $cyear = absint( $_GET['year'] );
                                                        }
                                                        $max   = $model->get_year_max();
                                                        $min   = $model->get_year_min();
                                                        $years = range( $min, $max );
                                                        foreach( $years as $year ) 
                                                        {
                                                            $sltd = '';
                                                            if ( $year == $cyear ) {
                                                                $sltd = ' selected="selected"';
                                                            }
                                                            echo '<option value="'.$year.'"'.$sltd.'>'.$year.'</option>';
                                                        }
                                                        ?>
                                                    </select>
                                                </span>
                                                <input type="hidden" name="page" value="iptrank">
                                                <input type="hidden" name="action" value="view_site">
                                                <input type="hidden" name="id" value="<?php echo $rank->rank_id; ?>">
                                                <button type="submit" name="" id="iptrank-do-filter" class="ipadm-btn ipadm-btn-primary"><?php _e( 'Generate', 'iptrank' ); ?></button>
                                            </form>
                                        </div>
                                        <?php
                                        /*
                                        <div class="iptrank-report-download">
                                            <a href="#" id="iptrank-download-pdf" class="ipadm-btn ipadm-btn-default"><i class="faip fa-download"></i></a>
                                        </div>
                                        */
                                        ?>
                                    </div>
                                    <?php
                                    $month_name = '';
                                    if ( array_key_exists( $cmonth, $months )) {
                                        $month_name = $months[$cmonth];
                                    }
                                    if ( $cdate == 1 ) {
                                        $dttitle = $month_name . ' ' . $cyear;
                                    } else {
                                        $dttitle = $cyear;
                                    }
                                    ?>
                                    <h3 class="iptrank-page-section"><?php printf( __( 'Ranking on %s', 'iptrank' ), $dttitle ); ?></h3>
                                    
                                    <script type="text/javascript" src="https://www.google.com/jsapi"></script>
                                    
                                    <div class="iptrank-report-main">
                                        <div class="iptrank-report-chart">
                                            
                                                <script type="text/javascript">
                                                    google.load("visualization", "1", {packages:["corechart"]});
                                                    google.setOnLoadCallback(drawChart);
                                                    function drawChart() {
                                                        
                                                        var dataTable = new google.visualization.DataTable();
                                                        dataTable.addColumn( 'date', '<?php _e( 'Date', 'iptrank' ); ?>' );
                                                        dataTable.addColumn( 'number', '<?php _e( 'Rank', 'iptrank' ); ?>' );
                                                        
                                                        var rows = [
                                                        <?php
                                                        $results = $model->get_report_main_data( $csite, $cgroup, $cdate, $cyear, $cmonth );
                                                        if ( ! empty( $results )) {
                                                            foreach( $results as $data )
                                                            {
                                                                    $timestamp = strtotime( $data->rdate );
                                                                    $phpdate   = getdate($timestamp);
                                                                    echo '[new Date(' 
                                                                        . $phpdate['year'] . ', '
                                                                        . ( $phpdate['mon']  - 1 ) . ', '
                                                                        . $phpdate['mday'] . ',0,0,0), '
                                                                        . $data->rank
                                                                    . '],';
                                                            }
                                                        }
                                                        ?>
                                                        ];
                                                        dataTable.addRows( rows );
                                                        
                                                        <?php
                                                        if ( $cdate == 1 ) {
                                                            $format = "{format:'d'}";
                                                        } else {
                                                            $format = "{format:'MMM, d'}";
                                                        }
                                                        ?>
                                                        var options = {
                                                            series: [{pointSize:6}],
                                                            hAxis: <?php echo $format; ?>
                                                        };
                                                        var chart = new google.visualization.LineChart(document.getElementById('iptrank-chart-div'));
                                                        chart.draw(dataTable, options);
                                                        
                                                        //Chart pie outranking
                                                        <?php
                                                        $up   = $model->get_outranking_up( $csite, $cgroup, $cdate, $cyear, $cmonth );
                                                        $down = $model->get_outranking_down( $csite, $cgroup, $cdate, $cyear, $cmonth );
                                                        ?>
                                                        var data = google.visualization.arrayToDataTable([
                                                          ['Outranking', 'Percent'],
                                                          ['<?php _e( 'Up', 'iptrank' ); ?>',   <?php echo $up; ?>],
                                                          ['<?php _e( 'Down', 'iptrank' ); ?>', <?php echo $down; ?>]
                                                        ]);
                                                        var options = {
                                                          title: '<?php printf( __( 'Ranking on %s vs Outranking', 'iptrank' ), $dttitle ); ?>'
                                                        };
                                                        var chart2 = new google.visualization.PieChart(document.getElementById('iptrank-chart-outranking'));
                                                        chart2.draw(data, options);
                                                        
                                                        //Chart pie summary
                                                        <?php
                                                        $top3   = $model->get_ranking_top( 3, $csite, $cgroup, $cdate, $cyear, $cmonth );
                                                        $top10  = $model->get_ranking_top( 10, $csite, $cgroup, $cdate, $cyear, $cmonth );
                                                        $top100 = $model->get_ranking_top( 100, $csite, $cgroup, $cdate, $cyear, $cmonth );
                                                        ?>
                                                        var data = google.visualization.arrayToDataTable([
                                                          ['Summary', 'Percent'],
                                                          ['<?php _e( 'In Top 3', 'iptrank' ); ?>',     <?php echo $top3; ?>],
                                                          ['<?php _e( 'In Top 10', 'iptrank' ); ?>',    <?php echo $top10; ?>],
                                                          ['<?php _e( 'In Top 100', 'iptrank' ); ?>',   <?php echo $top100; ?>]
                                                        ]);
                                                        var options = {
                                                          title: '<?php printf( __( 'Ranking on %s Summary', 'iptrank' ), $dttitle ); ?>'
                                                        };
                                                        var chart3 = new google.visualization.PieChart(document.getElementById('iptrank-chart-summary'));
                                                        chart3.draw(data, options);
                                                    }
                                                </script>
                                            <div id="iptrank-chart-div" style="width: 100%; height: 400px;"></div>
                                        </div>
                                        <div class="iptrank-report-chart-pie ipadm-clear">
                                            <div class="iptrank-chart-pie">
                                                <div id="iptrank-chart-outranking" style="width: 100%; height: 320px;"></div>
                                            </div>
                                            <div class="iptrank-chart-pie">
                                                <div id="iptrank-chart-summary" style="width: 100%; height: 320px;"></div>
                                            </div>
                                        </div>
                                    </div>
                                    
                                    <div class="iptrank-report-data">
                                        <div class="iptrank-report-section ipadm-clear">
                                            <div id="iptrank-report-last-records" class="iptrank-report-block">
                                                <h4 class="iptrank-page-section"><?php _e( '5 Last Ranking Records', 'iptrank' ); ?></h4>
                                                <table class="iptrank-stat-table">
                                                    <thead>
                                                        <tr>
                                                            <th><?php _e( 'No', 'iptrank' ); ?></th>
                                                            <th><?php _e( 'Keyword', 'iptrank' ); ?></th>
                                                            <th><?php _e( 'Date', 'iptrank' ); ?></th>
                                                            <th><?php _e( 'Rank', 'iptrank' ); ?></th>
                                                        </tr>
                                                    </thead>
                                                    <tbody>
                                                    <?php
                                                    $records = $model->get_last_records_site( 5, $csite, $cgroup, $cdate, $cyear, $cmonth );
                                                    if ( ! empty( $records )) :
                                                        $idx = 1;
                                                        foreach( $records as $record ):
                                                    ?>
                                                        <tr>
                                                            <td><?php echo $idx; ?></td>
                                                            <td><?php echo $record->rank_keyword; ?></td>
                                                            <td><?php echo mysql2date( 'd M y, h:i', $record->reco_date ); ?></td>
                                                            <td>
                                                                <?php
                                                                $value = $record->reco_value;
                                                                if ( $value > 100 ) {
                                                                    $value = '100+';
                                                                }
                                                                $value = '<span class="iptrank-rank-value">' . $value . '</span>';
                                                                //Progress
                                                                if ( $record->reco_progress > 0 ) {
                                                                    $icon = '<span class="ipadm-btn ipadm-btn-success ipadm-btn-small iptrank-rank-status"><i class="faip fa-long-arrow-up"></i></span>';
                                                                } elseif ( $record->reco_progress == 0 ) {
                                                                    $icon = '<span class="ipadm-btn ipadm-btn-warning ipadm-btn-small iptrank-rank-status"><i class="faip fa-arrows-h"></i></span>';
                                                                } else {
                                                                    $icon = '<span class="ipadm-btn ipadm-btn-danger ipadm-btn-small iptrank-rank-status"><i class="faip fa-long-arrow-down"></i></span>';
                                                                }
                                                                $value .= $icon;
                                                                if ( ! empty( $record->reco_progress )) {
                                                                    if ( $record->rank_progress > 0 ) {
                                                                        $val = '+'.$record->rank_progress;
                                                                    } else {
                                                                        $val = $record->rank_progress;
                                                                    }
                                                                    $value .= "( $val )";
                                                                }
                                                                echo $value;
                                                                ?>
                                                            </td>
                                                        </tr>
                                                    <?php
                                                            $idx++;
                                                        endforeach;
                                                    endif;
                                                    ?>
                                                    </tbody>
                                                </table>
                                            </div>
                                            <div id="iptrank-report-best-records" class="iptrank-report-block">
                                                <h4 class="iptrank-page-section"><?php _e( '5 Best Ranking Records', 'iptrank' ); ?></h4>
                                                <table class="iptrank-stat-table">
                                                    <thead>
                                                        <tr>
                                                            <th><?php _e( 'No', 'iptrank' ); ?></th>
                                                            <th><?php _e( 'Keyword', 'iptrank' ); ?></th>
                                                            <th><?php _e( 'Date', 'iptrank' ); ?></th>
                                                            <th><?php _e( 'Rank', 'iptrank' ); ?></th>
                                                        </tr>
                                                    </thead>
                                                    <tbody>
                                                    <?php
                                                    $records = $model->get_best_records_site( 5, $csite, $cgroup, $cdate, $cyear, $cmonth );
                                                    if ( ! empty( $records )) :
                                                        $idx = 1;
                                                        foreach( $records as $record ):
                                                    ?>
                                                        <tr>
                                                            <td><?php echo $idx; ?></td>
                                                            <td><?php echo $record->rank_keyword; ?></td>
                                                            <td><?php echo mysql2date( 'd M y, h:i', $record->reco_date ); ?></td>
                                                            <td>
                                                                <?php
                                                                $value = $record->reco_value;
                                                                if ( $value > 100 ) {
                                                                    $value = '100+';
                                                                }
                                                                $value = '<span class="iptrank-rank-value">' . $value . '</span>';
                                                                //Progress
                                                                if ( $record->reco_progress > 0 ) {
                                                                    $icon = '<span class="ipadm-btn ipadm-btn-success ipadm-btn-small iptrank-rank-status"><i class="faip fa-long-arrow-up"></i></span>';
                                                                } elseif ( $record->reco_progress == 0 ) {
                                                                    $icon = '<span class="ipadm-btn ipadm-btn-warning ipadm-btn-small iptrank-rank-status"><i class="faip fa-arrows-h"></i></span>';
                                                                } else {
                                                                    $icon = '<span class="ipadm-btn ipadm-btn-danger ipadm-btn-small iptrank-rank-status"><i class="faip fa-long-arrow-down"></i></span>';
                                                                }
                                                                $value .= $icon;
                                                                if ( ! empty( $record->reco_progress )) {
                                                                    if ( $record->rank_progress > 0 ) {
                                                                        $val = '+'.$record->rank_progress;
                                                                    } else {
                                                                        $val = $record->rank_progress;
                                                                    }
                                                                    $value .= "( $val )";
                                                                }
                                                                echo $value;
                                                                ?>
                                                            </td>
                                                        </tr>
                                                    <?php
                                                            $idx++;
                                                        endforeach;
                                                    endif;
                                                    ?>
                                                    </tbody>
                                                </table>
                                                
                                            </div>
                                        </div>
                                        <div class="iptrank-report-section ipadm-clear">
                                            <div id="iptrank-report-went-up" class="iptrank-report-block">
                                                <h4 class="iptrank-page-section"><?php _e( 'Went Up', 'iptrank' ); ?></h4>
                                                <table class="iptrank-stat-table">
                                                    <thead>
                                                        <tr>
                                                            <th><?php _e( 'Keyword', 'iptrank' ); ?></th>
                                                            <th><?php _e( 'Domain', 'iptrank' ); ?></th>
                                                            <th><?php _e( 'Group', 'iptrank' ); ?></th>
                                                            <th><?php _e( 'Current Rank', 'iptrank' ); ?></th>
                                                        </tr>
                                                    </thead>
                                                    <tbody>
                                                    <?php
                                                    $records = $model->get_went_up( 5, $csite, $cgroup, $cdate, $cyear, $cmonth );
                                                    if ( ! empty( $records )) :
                                                        $idx = 1;
                                                        foreach( $records as $record ):
                                                    ?>
                                                        <tr>
                                                            <td><?php echo $record->rank_keyword; ?></td>
                                                            <td><?php echo $record->rank_site; ?></td>
                                                            <td><?php echo mysql2date( 'd M y, h:i', $record->reco_date ); ?></td>
                                                            <td>
                                                                <?php
                                                                $value = $record->rank_value;
                                                                if ( $value > 100 ) {
                                                                    $value = '100+';
                                                                }
                                                                $value = '<span class="iptrank-rank-value">' . $value . '</span>';
                                                                //Progress
                                                                $value .= '<span class="ipadm-btn ipadm-btn-success ipadm-btn-small iptrank-rank-status"><i class="faip fa-long-arrow-up"></i></span>';
                                                                if ( ! empty( $record->rank_progress )) {
                                                                    if ( $record->rank_progress > 0 ) {
                                                                        $val = '+'.$record->rank_progress;
                                                                    } else {
                                                                        $val = $record->rank_progress;
                                                                    }
                                                                    $value .= "( $val )";
                                                                }
                                                                echo $value;
                                                                ?>
                                                            </td>
                                                        </tr>
                                                    <?php
                                                            $idx++;
                                                        endforeach;
                                                    endif;
                                                    ?>
                                                    </tbody>
                                                </table>
                                            </div>
                                            <div id="iptrank-report-went-down" class="iptrank-report-block">
                                                <h4 class="iptrank-page-section"><?php _e( 'Went Down', 'iptrank' ); ?></h4>
                                                <table class="iptrank-stat-table">
                                                    <thead>
                                                        <tr>
                                                            <th><?php _e( 'Keyword', 'iptrank' ); ?></th>
                                                            <th><?php _e( 'Domain', 'iptrank' ); ?></th>
                                                            <th><?php _e( 'Group', 'iptrank' ); ?></th>
                                                            <th><?php _e( 'Current Rank', 'iptrank' ); ?></th>
                                                        </tr>
                                                    </thead>
                                                    <tbody>
                                                    <?php
                                                    $records = $model->get_went_down( 5, $csite, $cgroup, $cdate, $cyear, $cmonth );
                                                    if ( ! empty( $records )) :
                                                        $idx = 1;
                                                        foreach( $records as $record ):
                                                    ?>
                                                        <tr>
                                                            <td><?php echo $record->rank_keyword; ?></td>
                                                            <td><?php echo $record->rank_site; ?></td>
                                                            <td><?php echo $record->group_name; ?></td>
                                                            <td>
                                                                <?php
                                                                $value = $record->rank_value;
                                                                if ( $value > 100 ) {
                                                                    $value = '100+';
                                                                }
                                                                $value = '<span class="iptrank-rank-value">' . $value . '</span>';
                                                                //Progress
                                                                $value .= '<span class="ipadm-btn ipadm-btn-danger ipadm-btn-small iptrank-rank-status"><i class="faip fa-long-arrow-down"></i></span>';
                                                                if ( ! empty( $record->rank_progress )) {
                                                                    if ( $record->rank_progress > 0 ) {
                                                                        $val = '+'.$record->rank_progress;
                                                                    } else {
                                                                        $val = $record->rank_progress;
                                                                    }
                                                                    $value .= "( $val )";
                                                                }
                                                                echo $value;
                                                                ?>
                                                            </td>
                                                        </tr>
                                                    <?php
                                                            $idx++;
                                                        endforeach;
                                                    endif;
                                                    ?>
                                                    </tbody>
                                                </table>
                                                
                                            </div>
                                        </div>
                                        <div class="iptrank-report-section ipadm-clear">
                                            <div id="iptrank-report-current" class="iptrank-report-block">
                                                <h4 class="iptrank-page-section"><?php _e( 'All Current Rankings', 'iptrank' ); ?></h4>
                                                <table class="iptrank-stat-table">
                                                    <thead>
                                                        <tr>
                                                            <th><?php _e( 'Keyword', 'iptrank' ); ?></th>
                                                            <th><?php _e( 'Domain', 'iptrank' ); ?></th>
                                                            <th><?php _e( 'Group', 'iptrank' ); ?></th>
                                                            <th><?php _e( 'Current Rank', 'iptrank' ); ?></th>
                                                        </tr>
                                                    </thead>
                                                    <tbody>
                                                    <?php
                                                    $records = $model->get_current_ranks( $csite, $cgroup, $cdate, $cyear, $cmonth );
                                                    if ( ! empty( $records )) :
                                                        $idx = 1;
                                                        foreach( $records as $record ):
                                                    ?>
                                                        <tr>
                                                            <td><?php echo $record->rank_keyword; ?></td>
                                                            <td><?php echo $record->rank_site; ?></td>
                                                            <td><?php echo $record->group_name; ?></td>
                                                            <td>
                                                                <?php
                                                                $value = $record->rank_value;
                                                                if ( $value > 100 ) {
                                                                    $value = '100+';
                                                                }
                                                                $value = '<span class="iptrank-rank-value">' . $value . '</span>';
                                                                //Progress
                                                                if ( $record->rank_progress > 0 ) {
                                                                    $icon = '<span class="ipadm-btn ipadm-btn-success ipadm-btn-small iptrank-rank-status"><i class="faip fa-long-arrow-up"></i></span>';
                                                                } elseif ( $record->rank_progress == 0 ) {
                                                                    $icon = '<span class="ipadm-btn ipadm-btn-warning ipadm-btn-small iptrank-rank-status"><i class="faip fa-arrows-h"></i></span>';
                                                                } else {
                                                                    $icon = '<span class="ipadm-btn ipadm-btn-danger ipadm-btn-small iptrank-rank-status"><i class="faip fa-long-arrow-down"></i></span>';
                                                                }
                                                                $value .= $icon;
                                                                if ( ! empty( $record->rank_progress )) {
                                                                    if ( $record->rank_progress > 0 ) {
                                                                        $val = '+'.$record->rank_progress;
                                                                    } else {
                                                                        $val = $record->rank_progress;
                                                                    }
                                                                    $value .= "( $val )";
                                                                }
                                                                echo $value;
                                                                ?>
                                                            </td>
                                                        </tr>
                                                    <?php
                                                            $idx++;
                                                        endforeach;
                                                    endif;
                                                    ?>
                                                    </tbody>
                                                </table>
                                                
                                            </div>
                                            <div id="iptrank-report-summary" class="iptrank-report-block">
                                                <h4 class="iptrank-page-section"><?php _e( 'Summary', 'iptrank' ); ?></h4>
                                                <table class="iptrank-stat-table">
                                                    <thead>
                                                        <tr>
                                                            <th><?php _e( 'Position', 'iptrank' ); ?></th>
                                                            <th><?php _e( 'Keyword Count', 'iptrank' ); ?></th>
                                                        </tr>
                                                    </thead>
                                                    <tbody>
                                                        <?php
                                                        $nottop = $model->get_ranking_not_top( $csite, $cgroup, $cdate, $cyear, $cmonth );
                                                        ?>
                                                        <tr>
                                                            <td><?php _e( 'In Top 3', 'iptrank' ); ?></td>
                                                            <td><?php echo $top3; ?></td>
                                                        <tr>
                                                        </tr>
                                                            <td><?php _e( 'In Top 10', 'iptrank' ); ?></td>
                                                            <td><?php echo $top10; ?></td>
                                                        <tr>
                                                        </tr>
                                                            <td><?php _e( 'In Top 100', 'iptrank' ); ?></td>
                                                            <td><?php echo $top100; ?></td>
                                                        <tr>
                                                        </tr>
                                                            <td><?php _e( 'Not In Top 100', 'iptrank' ); ?></td>
                                                            <td><?php echo $nottop; ?></td>
                                                        </tr>
                                                    </tbody>
                                                </table>
                                            </div>
                                        </div>
                                    </div>
                                    
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        <?php
        }
        
        /**
         * Show content for rank report page
         *
         * @return void
         */
        public function report()
        {
            $model = new IPTrank_Model();
        ?>
            <div id="iptrank-admin" class="wrap ipadm-wrap iptrank-admin">
                <div class="ipadm-inner">
                    <div class="ipadm-header">
                        <div class="iptrank-page-title">
                            <h1><?php _e( 'EZ Rank Track', 'iptrank' ); ?></h1>
                        </div>
                        <div class="iptrank-page-subtitle">
                            <h3><?php _e( 'Ranking Reports', 'iptrank' ); ?></h3>
                        </div>
                    </div>
                    <div class="ipadm-body">
                        <div class="ipadm-main">
                            <div class="ipadm-manage">
                                
                                <div id="iptrank-all-report">
                                    <div class="iptrank-report-nav ipadm-clear">
                                        <div class="iptrank-report-filter">
                                            <form action="" method="get">
                                                <select name="site" id="iptrank-input-site">
                                                    <option value="0"><?php _e( 'Show All Sites', 'iptrank' ); ?></option>
                                                    <?php
                                                    $csite = 0;
                                                    if ( ! empty( $_GET['site'] )) {
                                                        $csite = esc_url_raw( urldecode( $_GET['site'] ) );
                                                    }
                                                    $sites = $model->get_sites();
                                                    if ( ! empty( $sites )) {
                                                        foreach( $sites as $site ) 
                                                        {
                                                            $sltd = '';
                                                            if ( $site === $csite ) {
                                                                $sltd = ' selected="selected"';
                                                            }
                                                            echo '<option value="'.urlencode( $site ).'"'.$sltd.'>'.$site.'</option>';
                                                        }
                                                    }
                                                    ?>
                                                </select>
                                                <select name="group" id="iptrank-input-group">
                                                    <option value="0"><?php _e( 'Show All Groups', 'iptrank' ); ?></option>
                                                    <?php
                                                    $cgroup = 0;
                                                    if ( ! empty( $_GET['group'] )) {
                                                        $cgroup = absint( $_GET['group'] );
                                                    }
                                                    $groups = $model->get_groups();
                                                    if ( ! empty( $groups )) {
                                                        foreach( $groups as $group ) 
                                                        {
                                                            $sltd = '';
                                                            if ( $group->group_id == $cgroup ) {
                                                                $sltd = ' selected="selected"';
                                                            }
                                                            echo '<option value="'.$group->group_id.'"'.$sltd.'>'.$group->group_name.'</option>';
                                                        }
                                                    }
                                                    ?>
                                                </select>
                                                <select name="date" id="iptrank-input-date">
                                                    <?php
                                                    $cdate = 1;
                                                    if ( ! empty( $_GET['date'] )) {
                                                        $cdate = absint( $_GET['date'] );
                                                    }
                                                    $dates = array(
                                                        1 => __( 'By Month', 'iptrank' ),
                                                        2 => __( 'By Year', 'iptrank' )
                                                    );
                                                    foreach( $dates as $key => $name ) 
                                                    {
                                                        $sltd = '';
                                                        if ( $key === $cdate ) {
                                                            $sltd = ' selected="selected"';
                                                        }
                                                        echo '<option value="'.$key.'"'.$sltd.'>'.$name.'</option>';
                                                    }
                                                    ?>
                                                </select>
                                                <?php
                                                $dsp = ' style="display:none;"';
                                                if ( $cdate == 1 ) {
                                                    $dsp = '';
                                                }
                                                ?>
                                                <span id="iptrank-field-month" class="iptrank-filter-field"<?php echo $dsp; ?>>
                                                    <select name="month" id="iptrank-input-month">
                                                        <?php
                                                        $cmonth = date( 'm' );
                                                        if ( ! empty( $_GET['month'] )) {
                                                            $cmonth = preg_replace( '@[^0-9]@', '', $_GET['month'] );
                                                        }
                                                        $months = array(
                                                            '01' => __( 'Jan', 'iptrank' ),
                                                            '02' => __( 'Feb', 'iptrank' ),
                                                            '03' => __( 'Apr', 'iptrank' ),
                                                            '04' => __( 'Mar', 'iptrank' ),
                                                            '05' => __( 'May', 'iptrank' ),
                                                            '06' => __( 'Jun', 'iptrank' ),
                                                            '07' => __( 'Jul', 'iptrank' ),
                                                            '08' => __( 'Aug', 'iptrank' ),
                                                            '09' => __( 'Sep', 'iptrank' ),
                                                            '10' => __( 'Oct', 'iptrank' ),
                                                            '11' => __( 'Nov', 'iptrank' ),
                                                            '12' => __( 'Dec', 'iptrank' )
                                                        );
                                                        foreach( $months as $id => $name )
                                                        {
                                                            $sltd = '';
                                                            if ( $id == $cmonth ) {
                                                                $sltd = ' selected="selected"';
                                                            }
                                                            echo '<option value="'.$id.'"'.$sltd.'>'.$name.'</option>';
                                                        }
                                                        ?>
                                                    </select>
                                                </span>
                                                <span id="iptrank-field-year" class="iptrank-filter-field">
                                                    <select name="year" id="iptrank-input-year">
                                                        <?php
                                                        $cyear = date( 'Y' );
                                                        if ( ! empty( $_GET['year'] )) {
                                                            $cyear = absint( $_GET['year'] );
                                                        }
                                                        $max   = $model->get_year_max();
                                                        $min   = $model->get_year_min();
                                                        $years = range( $min, $max );
                                                        foreach( $years as $year ) 
                                                        {
                                                            $sltd = '';
                                                            if ( $year == $cyear ) {
                                                                $sltd = ' selected="selected"';
                                                            }
                                                            echo '<option value="'.$year.'"'.$sltd.'>'.$year.'</option>';
                                                        }
                                                        ?>
                                                    </select>
                                                </span>
                                                <input type="hidden" name="page" value="iptrank_report">
                                                <button type="submit" name="" id="iptrank-do-filter" class="ipadm-btn ipadm-btn-primary"><?php _e( 'Generate', 'iptrank' ); ?></button>
                                            </form>
                                        </div>
                                        <?php
                                        /*
                                        <div class="iptrank-report-download">
                                            <a href="#" id="iptrank-download-pdf" class="ipadm-btn ipadm-btn-default"><i class="faip fa-download"></i></a>
                                        </div>
                                        */
                                        ?>
                                    </div>
                                    <?php
                                    $month_name = '';
                                    if ( array_key_exists( $cmonth, $months )) {
                                        $month_name = $months[$cmonth];
                                    }
                                    if ( $cdate == 1 ) {
                                        $dttitle = $month_name . ' ' . $cyear;
                                    } else {
                                        $dttitle = $cyear;
                                    }
                                    ?>
                                    <h3 class="iptrank-page-section"><?php printf( __( 'Ranking on %s', 'iptrank' ), $dttitle ); ?></h3>
                                    
                                    <script type="text/javascript" src="https://www.google.com/jsapi"></script>
                                    
                                    <div class="iptrank-report-main">
                                        <div class="iptrank-report-chart">
                                            
                                                <script type="text/javascript">
                                                    google.load("visualization", "1", {packages:["corechart"]});
                                                    google.setOnLoadCallback(drawChart);
                                                    function drawChart() {
                                                        
                                                        var dataTable = new google.visualization.DataTable();
                                                        dataTable.addColumn( 'date', '<?php _e( 'Date', 'iptrank' ); ?>' );
                                                        dataTable.addColumn( 'number', '<?php _e( 'Rank', 'iptrank' ); ?>' );
                                                        
                                                        var rows = [
                                                        <?php
                                                        $results = $model->get_report_main_data( $csite, $cgroup, $cdate, $cyear, $cmonth );
                                                        if ( ! empty( $results )) {
                                                            foreach( $results as $data )
                                                            {
                                                                    $timestamp = strtotime( $data->rdate );
                                                                    $phpdate   = getdate($timestamp);
                                                                    echo '[new Date(' 
                                                                        . $phpdate['year'] . ', '
                                                                        . ( $phpdate['mon']  - 1 ) . ', '
                                                                        . $phpdate['mday'] . ',0,0,0), '
                                                                        . $data->rank
                                                                    . '],';
                                                            }
                                                        }
                                                        ?>
                                                        ];
                                                        dataTable.addRows( rows );
                                                        
                                                        <?php
                                                        if ( $cdate == 1 ) {
                                                            $format = "{format:'d'}";
                                                        } else {
                                                            $format = "{format:'MMM, d'}";
                                                        }
                                                        ?>
                                                        var options = {
                                                            series: [{pointSize:6}],
                                                            hAxis: <?php echo $format; ?>
                                                        };
                                                        var chart = new google.visualization.LineChart(document.getElementById('iptrank-chart-div'));
                                                        chart.draw(dataTable, options);
                                                        
                                                        //Chart pie outranking
                                                        <?php
                                                        $up   = $model->get_outranking_up( $csite, $cgroup, $cdate, $cyear, $cmonth );
                                                        $down = $model->get_outranking_down( $csite, $cgroup, $cdate, $cyear, $cmonth );
                                                        ?>
                                                        var data = google.visualization.arrayToDataTable([
                                                          ['Outranking', 'Percent'],
                                                          ['<?php _e( 'Up', 'iptrank' ); ?>',   <?php echo $up; ?>],
                                                          ['<?php _e( 'Down', 'iptrank' ); ?>', <?php echo $down; ?>]
                                                        ]);
                                                        var options = {
                                                          title: '<?php printf( __( 'Ranking on %s vs Outranking', 'iptrank' ), $dttitle ); ?>'
                                                        };
                                                        var chart2 = new google.visualization.PieChart(document.getElementById('iptrank-chart-outranking'));
                                                        chart2.draw(data, options);
                                                        
                                                        //Chart pie summary
                                                        <?php
                                                        $top3   = $model->get_ranking_top( 3, $csite, $cgroup, $cdate, $cyear, $cmonth );
                                                        $top10  = $model->get_ranking_top( 10, $csite, $cgroup, $cdate, $cyear, $cmonth );
                                                        $top100 = $model->get_ranking_top( 100, $csite, $cgroup, $cdate, $cyear, $cmonth );
                                                        ?>
                                                        var data = google.visualization.arrayToDataTable([
                                                          ['Summary', 'Percent'],
                                                          ['<?php _e( 'In Top 3', 'iptrank' ); ?>',     <?php echo $top3; ?>],
                                                          ['<?php _e( 'In Top 10', 'iptrank' ); ?>',    <?php echo $top10; ?>],
                                                          ['<?php _e( 'In Top 100', 'iptrank' ); ?>',   <?php echo $top100; ?>]
                                                        ]);
                                                        var options = {
                                                          title: '<?php printf( __( 'Ranking on %s Summary', 'iptrank' ), $dttitle ); ?>'
                                                        };
                                                        var chart3 = new google.visualization.PieChart(document.getElementById('iptrank-chart-summary'));
                                                        chart3.draw(data, options);
                                                    }
                                                </script>
                                            <div id="iptrank-chart-div" style="width: 100%; height: 400px;"></div>
                                        </div>
                                        <div class="iptrank-report-chart-pie ipadm-clear">
                                            <div class="iptrank-chart-pie">
                                                <div id="iptrank-chart-outranking" style="width: 100%; height: 320px;"></div>
                                            </div>
                                            <div class="iptrank-chart-pie">
                                                <div id="iptrank-chart-summary" style="width: 100%; height: 320px;"></div>
                                            </div>
                                        </div>
                                    </div>
                                    
                                    <div class="iptrank-report-data">
                                        <div class="iptrank-report-section ipadm-clear">
                                            <div id="iptrank-report-last-records" class="iptrank-report-block">
                                                <h4 class="iptrank-page-section"><?php _e( '5 Last Ranking Records', 'iptrank' ); ?></h4>
                                                <table class="iptrank-stat-table">
                                                    <thead>
                                                        <tr>
                                                            <th><?php _e( 'No', 'iptrank' ); ?></th>
                                                            <th><?php _e( 'Keyword', 'iptrank' ); ?></th>
                                                            <th><?php _e( 'Date', 'iptrank' ); ?></th>
                                                            <th><?php _e( 'Rank', 'iptrank' ); ?></th>
                                                        </tr>
                                                    </thead>
                                                    <tbody>
                                                    <?php
                                                    $records = $model->get_last_records_site( 5, $csite, $cgroup, $cdate, $cyear, $cmonth );
                                                    if ( ! empty( $records )) :
                                                        $idx = 1;
                                                        foreach( $records as $record ):
                                                    ?>
                                                        <tr>
                                                            <td><?php echo $idx; ?></td>
                                                            <td><?php echo $record->rank_keyword; ?></td>
                                                            <td><?php echo mysql2date( 'd M y, h:i', $record->reco_date ); ?></td>
                                                            <td>
                                                                <?php
                                                                $value = $record->reco_value;
                                                                if ( $value > 100 ) {
                                                                    $value = '100+';
                                                                }
                                                                $value = '<span class="iptrank-rank-value">' . $value . '</span>';
                                                                //Progress
                                                                if ( $record->reco_progress > 0 ) {
                                                                    $icon = '<span class="ipadm-btn ipadm-btn-success ipadm-btn-small iptrank-rank-status"><i class="faip fa-long-arrow-up"></i></span>';
                                                                } elseif ( $record->reco_progress == 0 ) {
                                                                    $icon = '<span class="ipadm-btn ipadm-btn-warning ipadm-btn-small iptrank-rank-status"><i class="faip fa-arrows-h"></i></span>';
                                                                } else {
                                                                    $icon = '<span class="ipadm-btn ipadm-btn-danger ipadm-btn-small iptrank-rank-status"><i class="faip fa-long-arrow-down"></i></span>';
                                                                }
                                                                $value .= $icon;
                                                                if ( ! empty( $record->reco_progress )) {
                                                                    if ( $record->rank_progress > 0 ) {
                                                                        $val = '+'.$record->rank_progress;
                                                                    } else {
                                                                        $val = $record->rank_progress;
                                                                    }
                                                                    $value .= "( $val )";
                                                                }
                                                                echo $value;
                                                                ?>
                                                            </td>
                                                        </tr>
                                                    <?php
                                                            $idx++;
                                                        endforeach;
                                                    endif;
                                                    ?>
                                                    </tbody>
                                                </table>
                                            </div>
                                            <div id="iptrank-report-best-records" class="iptrank-report-block">
                                                <h4 class="iptrank-page-section"><?php _e( '5 Best Ranking Records', 'iptrank' ); ?></h4>
                                                <table class="iptrank-stat-table">
                                                    <thead>
                                                        <tr>
                                                            <th><?php _e( 'No', 'iptrank' ); ?></th>
                                                            <th><?php _e( 'Keyword', 'iptrank' ); ?></th>
                                                            <th><?php _e( 'Date', 'iptrank' ); ?></th>
                                                            <th><?php _e( 'Rank', 'iptrank' ); ?></th>
                                                        </tr>
                                                    </thead>
                                                    <tbody>
                                                    <?php
                                                    $records = $model->get_best_records_site( 5, $csite, $cgroup, $cdate, $cyear, $cmonth );
                                                    if ( ! empty( $records )) :
                                                        $idx = 1;
                                                        foreach( $records as $record ):
                                                    ?>
                                                        <tr>
                                                            <td><?php echo $idx; ?></td>
                                                            <td><?php echo $record->rank_keyword; ?></td>
                                                            <td><?php echo mysql2date( 'd M y, h:i', $record->reco_date ); ?></td>
                                                            <td>
                                                                <?php
                                                                $value = $record->reco_value;
                                                                if ( $value > 100 ) {
                                                                    $value = '100+';
                                                                }
                                                                $value = '<span class="iptrank-rank-value">' . $value . '</span>';
                                                                //Progress
                                                                if ( $record->reco_progress > 0 ) {
                                                                    $icon = '<span class="ipadm-btn ipadm-btn-success ipadm-btn-small iptrank-rank-status"><i class="faip fa-long-arrow-up"></i></span>';
                                                                } elseif ( $record->reco_progress == 0 ) {
                                                                    $icon = '<span class="ipadm-btn ipadm-btn-warning ipadm-btn-small iptrank-rank-status"><i class="faip fa-arrows-h"></i></span>';
                                                                } else {
                                                                    $icon = '<span class="ipadm-btn ipadm-btn-danger ipadm-btn-small iptrank-rank-status"><i class="faip fa-long-arrow-down"></i></span>';
                                                                }
                                                                $value .= $icon;
                                                                if ( ! empty( $record->reco_progress )) {
                                                                    if ( $record->rank_progress > 0 ) {
                                                                        $val = '+'.$record->rank_progress;
                                                                    } else {
                                                                        $val = $record->rank_progress;
                                                                    }
                                                                    $value .= "( $val )";
                                                                }
                                                                echo $value;
                                                                ?>
                                                            </td>
                                                        </tr>
                                                    <?php
                                                            $idx++;
                                                        endforeach;
                                                    endif;
                                                    ?>
                                                    </tbody>
                                                </table>
                                                
                                            </div>
                                        </div>
                                        <div class="iptrank-report-section ipadm-clear">
                                            <div id="iptrank-report-went-up" class="iptrank-report-block">
                                                <h4 class="iptrank-page-section"><?php _e( 'Went Up', 'iptrank' ); ?></h4>
                                                <table class="iptrank-stat-table">
                                                    <thead>
                                                        <tr>
                                                            <th><?php _e( 'Keyword', 'iptrank' ); ?></th>
                                                            <th><?php _e( 'Domain', 'iptrank' ); ?></th>
                                                            <th><?php _e( 'Group', 'iptrank' ); ?></th>
                                                            <th><?php _e( 'Current Rank', 'iptrank' ); ?></th>
                                                        </tr>
                                                    </thead>
                                                    <tbody>
                                                    <?php
                                                    $records = $model->get_went_up( 5, $csite, $cgroup, $cdate, $cyear, $cmonth );
                                                    if ( ! empty( $records )) :
                                                        $idx = 1;
                                                        foreach( $records as $record ):
                                                    ?>
                                                        <tr>
                                                            <td><?php echo $record->rank_keyword; ?></td>
                                                            <td><?php echo $record->rank_site; ?></td>
                                                            <td><?php echo mysql2date( 'd M y, h:i', $record->reco_date ); ?></td>
                                                            <td>
                                                                <?php
                                                                $value = $record->rank_value;
                                                                if ( $value > 100 ) {
                                                                    $value = '100+';
                                                                }
                                                                $value = '<span class="iptrank-rank-value">' . $value . '</span>';
                                                                //Progress
                                                                $value .= '<span class="ipadm-btn ipadm-btn-success ipadm-btn-small iptrank-rank-status"><i class="faip fa-long-arrow-up"></i></span>';
                                                                if ( ! empty( $record->rank_progress )) {
                                                                    if ( $record->rank_progress > 0 ) {
                                                                        $val = '+'.$record->rank_progress;
                                                                    } else {
                                                                        $val = $record->rank_progress;
                                                                    }
                                                                    $value .= "( $val )";
                                                                }
                                                                echo $value;
                                                                ?>
                                                            </td>
                                                        </tr>
                                                    <?php
                                                            $idx++;
                                                        endforeach;
                                                    endif;
                                                    ?>
                                                    </tbody>
                                                </table>
                                            </div>
                                            <div id="iptrank-report-went-down" class="iptrank-report-block">
                                                <h4 class="iptrank-page-section"><?php _e( 'Went Down', 'iptrank' ); ?></h4>
                                                <table class="iptrank-stat-table">
                                                    <thead>
                                                        <tr>
                                                            <th><?php _e( 'Keyword', 'iptrank' ); ?></th>
                                                            <th><?php _e( 'Domain', 'iptrank' ); ?></th>
                                                            <th><?php _e( 'Group', 'iptrank' ); ?></th>
                                                            <th><?php _e( 'Current Rank', 'iptrank' ); ?></th>
                                                        </tr>
                                                    </thead>
                                                    <tbody>
                                                    <?php
                                                    $records = $model->get_went_down( 5, $csite, $cgroup, $cdate, $cyear, $cmonth );
                                                    if ( ! empty( $records )) :
                                                        $idx = 1;
                                                        foreach( $records as $record ):
                                                    ?>
                                                        <tr>
                                                            <td><?php echo $record->rank_keyword; ?></td>
                                                            <td><?php echo $record->rank_site; ?></td>
                                                            <td><?php echo $record->group_name; ?></td>
                                                            <td>
                                                                <?php
                                                                $value = $record->rank_value;
                                                                if ( $value > 100 ) {
                                                                    $value = '100+';
                                                                }
                                                                $value = '<span class="iptrank-rank-value">' . $value . '</span>';
                                                                //Progress
                                                                $value .= '<span class="ipadm-btn ipadm-btn-danger ipadm-btn-small iptrank-rank-status"><i class="faip fa-long-arrow-down"></i></span>';
                                                                if ( ! empty( $record->rank_progress )) {
                                                                    if ( $record->rank_progress > 0 ) {
                                                                        $val = '+'.$record->rank_progress;
                                                                    } else {
                                                                        $val = $record->rank_progress;
                                                                    }
                                                                    $value .= "( $val )";
                                                                }
                                                                echo $value;
                                                                ?>
                                                            </td>
                                                        </tr>
                                                    <?php
                                                            $idx++;
                                                        endforeach;
                                                    endif;
                                                    ?>
                                                    </tbody>
                                                </table>
                                                
                                            </div>
                                        </div>
                                        <div class="iptrank-report-section ipadm-clear">
                                            <div id="iptrank-report-current" class="iptrank-report-block">
                                                <h4 class="iptrank-page-section"><?php _e( 'All Current Rankings', 'iptrank' ); ?></h4>
                                                <table class="iptrank-stat-table">
                                                    <thead>
                                                        <tr>
                                                            <th><?php _e( 'Keyword', 'iptrank' ); ?></th>
                                                            <th><?php _e( 'Domain', 'iptrank' ); ?></th>
                                                            <th><?php _e( 'Group', 'iptrank' ); ?></th>
                                                            <th><?php _e( 'Current Rank', 'iptrank' ); ?></th>
                                                        </tr>
                                                    </thead>
                                                    <tbody>
                                                    <?php
                                                    $records = $model->get_current_ranks( $csite, $cgroup, $cdate, $cyear, $cmonth );
                                                    if ( ! empty( $records )) :
                                                        $idx = 1;
                                                        foreach( $records as $record ):
                                                    ?>
                                                        <tr>
                                                            <td><?php echo $record->rank_keyword; ?></td>
                                                            <td><?php echo $record->rank_site; ?></td>
                                                            <td><?php echo $record->group_name; ?></td>
                                                            <td>
                                                                <?php
                                                                $value = $record->rank_value;
                                                                if ( $value > 100 ) {
                                                                    $value = '100+';
                                                                }
                                                                $value = '<span class="iptrank-rank-value">' . $value . '</span>';
                                                                //Progress
                                                                if ( $record->rank_progress > 0 ) {
                                                                    $icon = '<span class="ipadm-btn ipadm-btn-success ipadm-btn-small iptrank-rank-status"><i class="faip fa-long-arrow-up"></i></span>';
                                                                } elseif ( $record->rank_progress == 0 ) {
                                                                    $icon = '<span class="ipadm-btn ipadm-btn-warning ipadm-btn-small iptrank-rank-status"><i class="faip fa-arrows-h"></i></span>';
                                                                } else {
                                                                    $icon = '<span class="ipadm-btn ipadm-btn-danger ipadm-btn-small iptrank-rank-status"><i class="faip fa-long-arrow-down"></i></span>';
                                                                }
                                                                $value .= $icon;
                                                                if ( ! empty( $record->rank_progress )) {
                                                                    if ( $record->rank_progress > 0 ) {
                                                                        $val = '+'.$record->rank_progress;
                                                                    } else {
                                                                        $val = $record->rank_progress;
                                                                    }
                                                                    $value .= "( $val )";
                                                                }
                                                                echo $value;
                                                                ?>
                                                            </td>
                                                        </tr>
                                                    <?php
                                                            $idx++;
                                                        endforeach;
                                                    endif;
                                                    ?>
                                                    </tbody>
                                                </table>
                                                
                                            </div>
                                            <div id="iptrank-report-summary" class="iptrank-report-block">
                                                <h4 class="iptrank-page-section"><?php _e( 'Summary', 'iptrank' ); ?></h4>
                                                <table class="iptrank-stat-table">
                                                    <thead>
                                                        <tr>
                                                            <th><?php _e( 'Position', 'iptrank' ); ?></th>
                                                            <th><?php _e( 'Keyword Count', 'iptrank' ); ?></th>
                                                        </tr>
                                                    </thead>
                                                    <tbody>
                                                        <?php
                                                        $nottop = $model->get_ranking_not_top( $csite, $cgroup, $cdate, $cyear, $cmonth );
                                                        ?>
                                                        <tr>
                                                            <td><?php _e( 'In Top 3', 'iptrank' ); ?></td>
                                                            <td><?php echo $top3; ?></td>
                                                        <tr>
                                                        </tr>
                                                            <td><?php _e( 'In Top 10', 'iptrank' ); ?></td>
                                                            <td><?php echo $top10; ?></td>
                                                        <tr>
                                                        </tr>
                                                            <td><?php _e( 'In Top 100', 'iptrank' ); ?></td>
                                                            <td><?php echo $top100; ?></td>
                                                        <tr>
                                                        </tr>
                                                            <td><?php _e( 'Not In Top 100', 'iptrank' ); ?></td>
                                                            <td><?php echo $nottop; ?></td>
                                                        </tr>
                                                    </tbody>
                                                </table>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                                
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        <?php
        }
        
        /**
         * Show content for keyword research page
         *
         * @return void
         */
        public function research()
        {
            $model = new IPTrank_Model();
        ?>
            <script type="text/javascript">
                iptrank_research_msg = {
                    'keyword_empty' : '<?php _e( 'You must specify a keyword', 'iptrank' ); ?>'
                };
            </script>
            <div id="iptrank-admin" class="wrap ipadm-wrap iptrank-admin">
                <div class="ipadm-inner">
                    <div class="ipadm-header">
                        <div class="iptrank-page-title">
                            <h1><?php _e( 'EZ Rank Track', 'iptrank' ); ?></h1>
                        </div>
                        <div class="iptrank-page-subtitle">
                            <h3><?php _e( 'Research', 'iptrank' ); ?></h3>
                        </div>
                    </div>
                    <div class="ipadm-body">
                        <div class="ipadm-main">
                            <div class="ipadm-manage">
                                
<div id="iptrank-research">

    <form id="iptrank-research-form" action="<?php echo admin_url(); ?>admin-ajax.php?doajax=1&iptrank=1&action=iptrank_research" method="post">
        <div class="iptrank-field">
            <div class="iptrank-input">
                <input type="text" name="keyword" id="iptrank-input-keyword" class="ipadm-input" placeholder="<?php _e( 'Enter a keyword', 'iptrank' ); ?>">
            </div>
            <div class="iptrank-actions">
                <button type="submit" class="ipadm-btn ipadm-btn-primary ip-form-submit" id="iptrank-do-research">
                    <i class="faip fa-search"></i> <?php _e( 'Search', 'iptrank' ); ?>
                </button>
                <a href="" class="ipadm-btn ipadm-btn-default" id="iptrank-do-clear">
                    <i class="faip fa-times"></i> <?php _e( 'Clear', 'iptrank' ); ?>
                </a>
            </div>
        </div>
    </form>
    
    <div id="iptrank-research-result">
        <form method="post" action="">
            <div class="iptrank-result-top" style="display:none;">
                <p><?php printf( __( 'Keyword tool has found <strong>%s</strong> result.', 'iptrank' ), 0 ); ?></p>
            </div>
            <div class="iptrank-result-content">
                <div class="iptrank-result-empty">
                    <p><em><?php _e( 'Please enter a keyword in the form above to perform keyword research', 'iptrank' ); ?></em></p>
                </div>
                <div class="iptrank-result-main" style="display:none;"></div>
            </div>
            <div class="iptrank-result-bottom ipadm-clear" style="display:none;">
                <div class="iptrank-result-check">
                    <label>
                        <input type="checkbox" class="trigger iptrank-check-all" name="check_all" value="1">
                        <span><?php _e( 'Check/Uncheck All', 'iptrank' ); ?></span>
                    </label>
                </div>
                <div class="iptrank-result-actions">
                    <a href="#iptrank-popup-research" class="ipadm-btn ipadm-btn-success iptrank-btn-modal"><?php _e( 'Show as list', 'iptrank' ); ?></a>
                </div>
            </div>
        </form>
    </div>

</div>
                                
                            </div>
                        </div>
                    </div>
                </div>
            </div>

<div id="iptrank-popup-research" class="ip-ui-modal" style="display:none;">
    <div class="ip-ui-modal-main">
        <div class="ip-ui-modal-inner">
            <div class="ip-ui-modal-title">
                <h3><?php _e( 'Keyword Research', 'iptrank' ); ?></h3>
                <div class="ip-ui-close">
                    <a href="#"><i class="faip fa-times"></i></a>
                </div>
            </div>
            <div class="ip-ui-modal-content ip-form-cont">
                <form action="" method="post">
                    <div class="ipadm-field-row ipadm-field-box ipadm-clear">
                        <div class="ipadm-field">
                            <div class="ipadm-input-wrap">
                                <textarea id="iptrank-research-result-list" name="keyword_list" class="ipadm-input" rows="16"></textarea>
                            </div>
                        </div>
                    </div>
                </form>
            </div>
        </div>
    </div>
</div>
        <?php
        }
        
        /**
         * Show content for keyword research page
         *
         * @return void
         */
        public function setting()
        {
            $model = new IPTrank_Model();
        ?>
            <div id="iptrank-admin" class="wrap ipadm-wrap iptrank-admin">
                <div class="ipadm-inner">
                    <div class="ipadm-header">
                        <div class="iptrank-page-title">
                            <h1><?php _e( 'EZ Rank Track', 'iptrank' ); ?></h1>
                        </div>
                        <div class="iptrank-page-subtitle">
                            <h3><?php _e( 'Settings', 'iptrank' ); ?></h3>
                        </div>
                    </div>
                    <div class="ipadm-body">
                        <div class="ipadm-main">
                            <div class="ipadm-manage">
                                
<div id="iptrank-setting">
    <form id="iptrank-setting-form" action="<?php echo admin_url(); ?>admin-ajax.php?doajax=1&iptrank=1&action=iptrank_save_setting" post="method">
        <div class="ipgivay-fields">
        
            <div class="ipadm-field-row ipadm-field-inline ipadm-field-box ipadm-clear">
                <div class="ipadm-label">
                    <label for="input-google-country"><?php _e( 'Google Country', 'ipgivay' ); ?></label>
                </div>
                <div class="ipadm-field">
                    <select name="google_country" id="input-google-country">
                        <?php
                        $current   = urldecode( get_option( 'iptrank_google_country' ) );
                        $countries = IPTrank_Engine::get_google_urls();
                        foreach( $countries as $url => $label ) 
                        {
                            $sltd = '';
                            if ( $current == $url ) {
                                $sltd = ' selected="selected"';
                            }
                            echo '<option value="' . $url . '"' . $sltd . '>' . $label . '</option>';
                        }
                        ?>
                    </select>
                </div>
            </div>
            <div class="ipadm-field-row ipadm-field-inline ipadm-field-box ipadm-clear">
                <div class="ipadm-label">
                    <label for="input-research-google"><?php _e( 'Keyword Research Google', 'ipgivay' ); ?></label>
                </div>
                <div class="ipadm-field">
                    <select name="research_google" id="input-research-google">
                        <?php
                        $current   = urldecode( get_option( 'iptrank_research_google' ) );
                        $countries = IPTrank_Engine::get_google_urls();
                        foreach( $countries as $url => $label ) 
                        {
                            $sltd = '';
                            if ( $current == $url ) {
                                $sltd = ' selected="selected"';
                            }
                            echo '<option value="' . $url . '"' . $sltd . '>' . $label . '</option>';
                        }
                        ?>
                    </select>
                </div>
            </div>
            <div class="ipadm-field-row ipadm-field-inline ipadm-field-box ipadm-clear">
                <div class="ipadm-label">
                    <label for="input-language-letter"><?php _e( 'Keyword Research Language Letter', 'ipgivay' ); ?></label>
                </div>
                <div class="ipadm-field">
                    <?php
                    $default = 'a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z';
                    $abjad   = get_option( 'iptrank_research_letter', $default );
                    ?>
                    <textarea id="ipadm-input" cols="80" rows="4" name="research_letter" id="input-language-letter"><?php echo $abjad; ?></textarea>
                </div>
            </div>
            <div class="ipadm-field-row ipadm-field-inline ipadm-field-box ipadm-clear">
                <div class="ipadm-label">
                    <label for="input-auto-update"><?php _e( 'Auto Update Rank', 'ipgivay' ); ?></label>
                </div>
                <div class="ipadm-field">
                    <select name="auto_update" id="input-auto-update">
                        <?php
                        $current = get_option( 'iptrank_auto_update' );
                        $options = array(
                            '0'   => __( 'None', 'iptrank' ),
                            '1'   => __( 'Every Day', 'iptrank' ),
                            '2'   => __( 'Every 2 Days', 'iptrank' ),
                            '3'   => __( 'Every 3 Days', 'iptrank' ),
                            '4'   => __( 'Every 4 Days', 'iptrank' ),
                            '5'   => __( 'Every 5 Days', 'iptrank' ),
                            '6'   => __( 'Every 6 Days', 'iptrank' ),
                            '7'   => __( 'Every Week', 'iptrank' )
                        );
                        foreach( $options as $day => $label ) 
                        {
                            $sltd = '';
                            if ( $current == $day ) {
                                $sltd = ' selected="selected"';
                            }
                            echo '<option value="' . $day . '"' . $sltd . '>' . $label . '</option>';
                        }
                        ?>
                    </select>
                    <p class="ipadm-info">
                        <?php _e( 'Set the automatic updating for all keywords. Updates will run every admin accessing the administrator page.', 'iptrank' ); ?>
                    </p>
                </div>
            </div>
            <div class="ipadm-field-row ipadm-field-inline ipadm-field-box ipadm-clear">
                <div class="ipadm-label">
                    <label for="input-cron-job"><?php _e( 'Cron Job', 'ipgivay' ); ?></label>
                </div>
                <div class="ipadm-field">
                    <label>
                        <?php
                        $checked = '';
                        $current = get_option( 'iptrank_cron_job' );
                        if ( ! empty( $current )) {
                            $checked = ' checked="checked"';
                        }
                        ?>
                        <input type="checkbox" id="input-cron-job" name="cron_job" value="1"<?php echo $checked; ?>>
                        <?php _e( 'Activate WordPress Cron Job that is triggered by the site visitors', 'iptrank' ); ?>
                    </label>
                </div>
            </div>
            <div class="ipadm-field-row ipadm-field-box ipadm-clear">
                <div class="ipadm-field">
                   <button type="button" class="ipadm-btn ipadm-btn-primary ipadm-btn-large ip-form-submit"><?php _e( 'Save settings', 'iptrank' ); ?></button>
                </div>
            </div>
            
        </div>
    </form>
</div>
                                
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        <?php
        }
        
        /**
         * Show content for log page
         *
         * @return void
         */
        public function Log()
        {
            wp_enqueue_script('jquery-ui-datepicker');
            $model = new IPTrank_Model();
        ?>
            <div id="iptrank-admin" class="wrap ipadm-wrap iptrank-admin">
                <div class="ipadm-inner">
                    <div class="ipadm-header">
                        <div class="iptrank-page-title">
                            <h1><?php _e( 'EZ Rank Track', 'iptrank' ); ?></h1>
                        </div>
                        <div class="iptrank-page-subtitle">
                            <h3><?php _e( 'Logs', 'iptrank' ); ?></h3>
                        </div>
                    </div>
                    <div class="ipadm-body">
                        <div class="ipadm-main">
                            <div class="ipadm-manage">
                                
                                <div class="iptrank-report-nav ipadm-clear">
                                    <div class="iptrank-report-filter">
<form action="" method="get">
    <div id="iptrank-log-filter-fields">
        <input type="hidden" name="page" value="iptrank_log" />
        <?php
        if ( ! empty( $_GET['cdatestart'] )) {
            $dateStart = $_GET['cdatestart'];
        } else {
            $dateStart = date('m/d/Y');
        }
        if ( ! empty( $_GET['cdateend'] )) {
            $dateEnd = $_GET['cdateend'];
        } else {
            $dateEnd = date('m/d/Y'); 
        }
        ?>
        <strong><?php _e( 'Filter By Date', 'iptrank' ); ?>: </strong>
        <span class="iptrank-date-input">
            <input type="text" id="iptrank-date-start" name="cdatestart" value="<?php echo $dateStart; ?>" />
            -
            <input type="text" id="iptrank-date-end" name="cdateend" value="<?php echo $dateEnd; ?>" />
        </span>
        <span class="iptrank-do-filter">
            <input type="submit" id="iptrank-filter-date" class="button button-primary" name="" value="<?php _e( 'Go', 'iptrank' ); ?>" />
        </span>
    </div>
</form>
                                    </div>
                                </div>
                                <div id="iptrank-log-manage">
                                    <form action="" method="get">
                                        <input type="hidden" name="page" value="iptrank">
                                        <?php
                                        require_once( IPTRANK_PATH . "includes/admin-table-log.php" );
                                        $table = new IPTrank_AdminTable_Log();
                                        $table->prepare_items();
                                        $table->display();
                                        ?>
                                    </form>
                                </div>
                                
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        <?php
        }
        
        /**
         * Show content group manage
         *
         * @return void
         */
        public function group()
        {
            if ( isset( $_GET['action'] ) && $_GET['action'] == 'edit' ) {
                $this->group_edit();
            } else {
                $this->group_manage();
            }
        }
        
        /**
         * Show content group manage
         *
         * @return void
         */
        public function group_manage()
        {
        ?>
            <script type="text/javascript">
                iptrank_group_msg = {
                    'name_empty'     : '<?php _e( 'You must specify group name', 'iptrank' ); ?>'
                };
            </script>
            <div id="iptrank-admin" class="wrap ipadm-wrap iptrank-admin">
                <div class="ipadm-inner">
                    <div class="ipadm-header">
                        <div class="iptrank-page-title">
                            <h1><?php _e( 'EZ Rank Track', 'iptrank' ); ?></h1>
                        </div>
                        <div class="iptrank-page-subtitle">
                            <h3><?php _e( 'Group', 'iptrank' ); ?></h3>
                        </div>
                    </div>
                    <?php
                    if ( isset( $_GET['create'] )) :
                    ?>
                    <div id="ipadm-messages" class="ipadm-success" style="display: block;">
                        <?php _e( 'Successfully create a group.', 'iptrank' ); ?>
                    </div>
                    <?php
                    endif;
                    ?>
                    <div class="ipadm-body">
                        <div class="ipadm-main">
                            <div class="ipadm-manage iptrank-manage-group ipadm-clear">
                                <div class="iptrank-form">
                                    <div class="iptrank-mng-inner">
                                        <h3>Add New Group</h3>
                                        <p><?php _e( 'Use the form below to add a new group.', 'iptrank' ); ?></p>
                                        <form id="iptrank-add-group-form" method="post" action="<?php echo admin_url(); ?>admin-ajax.php?doajax=1&iptrank=1&action=iptrank_save_group">
                                        
                <div class="iptrank-fields">
                    <input type="hidden" name="group_id" id="iptrank-val-groupid" value="0" />
                    <div class="ipadm-field-row ipadm-field-box ipadm-clear">
                        <div class="ipadm-label">
                            <label for="iptrank-input-name"><?php _e( 'Name', 'iptrank' ); ?> (*)</label>
                        </div>
                        <div class="ipadm-field">
                            <input type="text" class="ipadm-input ipadm-input-full" id="iptrank-input-name" name="name" value="" />
                            <p class="ipadm-info"><?php _e( 'The name is how it appears on your site.', 'iptrank' ); ?></p>
                        </div>
                    </div>
                    <div class="ipadm-field-row ipadm-field-box ipadm-clear">
                        <div class="ipadm-label">
                            <label for="iptrank-input-slug"><?php _e( 'Slug', 'iptrank' ); ?></label>
                        </div>
                        <div class="ipadm-field">
                            <input type="text" class="ipadm-input ipadm-input-full" id="iptrank-input-slug" name="slug" value="" />
                            <p class="ipadm-info"><?php _e( 'The &quot;slug&quot; is the URL-friendly version of the name. It is usually all lowercase and contains only letters, numbers, and hyphens.', 'iptrank' ); ?></p>
                        </div>
                    </div>
                    <div class="ipadm-field-row ipadm-field-box ipadm-clear">
                        <div class="ipadm-label">
                            <label for="iptrank-input-desc"><?php _e( 'Description', 'iptrank' ); ?></label>
                        </div>
                        <div class="ipadm-field">
                            <textarea class="ipadm-input ipadm-input-full" id="iptrank-input-desc" name="description"></textarea>
                            <p class="ipadm-info"><?php _e( 'The description is not prominent by default; however, some themes may show it.', 'iptrank' ); ?></p>
                        </div>
                    </div>
                    
                    <div class="iptrank-manage-footer clearfix">
                        <button type="button" class="ipadm-btn ipadm-btn-primary ipadm-btn-large ip-form-submit"><?php _e( 'Add new group', 'iptrank' ); ?></button>
                    </div>
                    
                </div>
                                        </form>
                                    </div>
                                </div>
                                <div class="iptrank-table">
                                    <div class="iptrank-mng-inner">
                                    
                                        <div class="ipadm-table iptrank-manage-table">
                                            <?php
                                            require_once( IPTRANK_PATH . "includes/admin-table-group.php" );
                                            $paginArgs = array(
                                                "per_page" => 20 
                                            );
                                            $table = new IPTrank_AdminTableGroup();
                                            $table->prepare_items();
                                            $table->display();
                                            ?>
                                        </div>
                                        
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        <?php
        }
        
        /**
         * Show content group edit
         *
         * @return void
         */
        public function group_edit()
        {
            $model = new IPTrank_Model();
            if ( empty( $_GET['id'] )) {
                wp_die( __('You attempted to edit an item that doesn&#8217;t exist. Perhaps it was deleted?', 'iptrank') );
            }
            $id = absint( $_GET['id'] );
            if ( ! $group = $model->get_group( $id ) ) {
                wp_die( __('You attempted to edit an item that doesn&#8217;t exist. Perhaps it was deleted?', 'iptrank') );
            }
        ?>
            <script type="text/javascript">
                iptrank_group_msg = {
                    'name_empty'     : '<?php _e( 'You must specify group name', 'iptrank' ); ?>'
                };
            </script>
            <div id="iptrank-admin" class="wrap ipadm-wrap iptrank-admin">
                <div class="ipadm-inner">
                    <div class="ipadm-header">
                        <div class="iptrank-page-title">
                            <h1><?php _e( 'EZ Rank Track', 'iptrank' ); ?></h1>
                        </div>
                        <div class="iptrank-page-subtitle">
                            <h3><?php _e( 'Edit Group', 'iptrank' ); ?></h3>
                        </div>
                    </div>
                    <?php
                    if ( isset( $_GET['update'] )) :
                    ?>
                    <div id="ipadm-messages" class="ipadm-success" style="display: block;">
                        <?php _e( 'Successfully updating the group.', 'iptrank' ); ?>
                    </div>
                    <?php
                    endif;
                    ?>
                    <div class="ipadm-body">
                        <div class="ipadm-main">
                            <div class="ipadm-manage ipadm-clear">
                            
                                <form id="iptrank-edit-group-form" method="post" action="<?php echo admin_url(); ?>admin-ajax.php?doajax=1&iptrank=1&action=iptrank_save_group">
                                    <div class="ipadm-fields">
                                        
                                        <input type="hidden" name="group_id" id="iptrank-val-groupid" value="<?php echo $group->group_id; ?>" />
                                        <div class="ipadm-field-row ipadm-field-inline ipadm-field-box ipadm-clear">
                                            <div class="ipadm-label">
                                                <label for="iptrank-input-name"><?php _e( 'Name', 'iptrank' ); ?></label>
                                            </div>
                                            <div class="ipadm-field">
                                                <input class="ipadm-input" type="text" id="iptrank-input-name" value="<?php echo $group->group_name; ?>" size="30" name="name">
                                            </div>
                                        </div>
                                        <div class="ipadm-field-row ipadm-field-inline ipadm-field-box ipadm-clear">
                                            <div class="ipadm-label">
                                                <label for="iptrank-input-slug"><?php _e( 'Slug', 'iptrank' ); ?></label>
                                            </div>
                                            <div class="ipadm-field">
                                                <input class="ipadm-input" type="text" id="iptrank-input-slug" value="<?php echo $group->group_slug; ?>" size="30" name="slug">
                                            </div>
                                        </div>
                                        <div class="ipadm-field-row ipadm-field-inline ipadm-field-box ipadm-clear">
                                            <div class="ipadm-label">
                                                <label for="iptrank-input-desc"><?php _e( 'Description', 'iptrank' ); ?></label>
                                            </div>
                                            <div class="ipadm-field">
                                                <textarea class="ipadm-input" id="iptrank-input-desc" name="description" rows="6" style="width: 520px;"><?php echo $group->group_info; ?></textarea>
                                            </div>
                                        </div>
                                        
                                    </div>
                                
                                    <div class="iptrank-form-footer clearfix">
                                        <button type="button" class="ipadm-btn ipadm-btn-primary ipadm-btn-large ip-form-submit"><?php _e( 'Save Change', 'iptrank' ); ?></button>
                                    </div>
                                </form>
                                
                                
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        <?php
        }
    }
}
?>