<?php
if ( ! class_exists( 'IPTrank_RowRanks' )) 
{

    require_once( IPTRANK_PATH . "includes/admin-table.php" );
    
    /**
     * Class for display table of smart pop up
     */
    class IPTrank_RowRank extends IPTrank_AdminTable
    {
        /**
         * Take rank ids
         *
         * @var array
         **/
        protected $_ids;
        
        /**
         * Constructor. The child class should call this constructor from its own constructor
         *
         * @param array $args An associative array with information about the current table
         * @access protected
         */
        public function __construct( $ids, $args = array() )
        {
            $this->_ids = (array)$ids;
            parent::__construct( $args );
        }

        /**
         * Prepares the list of items for displaying.
         * @uses WP_List_Table::set_pagination_args()
         *
         */
        public function prepare_items() 
        {
            $model = new IPTrank_Model();
            $this->items = $model->get_ranks_byid( $this->_ids );
        }
    }

}
?>